subroutine DEALLOCATE_ARRAYS_NormalCirculation()    !  is called in module FluidFlowMain
    USE MudSystemVARIABLES
    implicit none


if(allocated(MudSystemDotXstart_PipeSection)) deallocate(MudSystemDotXstart_PipeSection)  
if(allocated(MudSystemDotXend_PipeSection)) deallocate(MudSystemDotXend_PipeSection)        
if(allocated(MudSystemDotPipeSection_VolumeCapacity)) deallocate(MudSystemDotPipeSection_VolumeCapacity)        
if(allocated(MudSystemDotArea_PipeSectionFt)) deallocate(MudSystemDotArea_PipeSectionFt)     
if(allocated(MudSystemDotOD_PipeSectionInch)) deallocate(MudSystemDotOD_PipeSectionInch)        
if(allocated(MudSystemDotID_PipeSectionInch)) deallocate(MudSystemDotID_PipeSectionInch)   
if(allocated(MudSystemDotXstart_OpSection)) deallocate(MudSystemDotXstart_OpSection)  
if(allocated(MudSystemDotXend_OpSection)) deallocate(MudSystemDotXend_OpSection)        
if(allocated(MudSystemDotArea_OpSectionFt)) deallocate(MudSystemDotArea_OpSectionFt)        
if(allocated(MudSystemDotOD_OpSectionInch)) deallocate(MudSystemDotOD_OpSectionInch)        
if(allocated(MudSystemDotID_OpSectionInch)) deallocate(MudSystemDotID_OpSectionInch)        
if(allocated(MudSystemDotOpSection_VolumeCapacity)) deallocate(MudSystemDotOpSection_VolumeCapacity)  
if(allocated(MudSystemDotGeoTypeOp)) deallocate(MudSystemDotGeoTypeOp)        
if(allocated(MudSystemDotGeoType)) deallocate(MudSystemDotGeoType)        


            call MudSystemDotHz_MudDischarged_Volume%Empty()
            call MudSystemDotHz_Mud_Backhead_X%Empty()
            call Hz_Mud_Backhead_section%Empty()
            call MudSystemDotHz_Mud_Forehead_X%Empty()
            call Hz_Mud_Forehead_section%Empty()
            call MudSystemDotHz_Density%Empty()
            call MudSystemDotHz_RemainedVolume_in_LastSection%Empty()
            call MudSystemDotHz_EmptyVolume_inBackheadLocation%Empty() 
            call Hz_MudOrKick%Empty()                                        
            
                                
            call MudSystemDotSt_MudDischarged_Volume%Empty()
            call MudSystemDotSt_Mud_Backhead_X%Empty()
            call St_Mud_Backhead_section%Empty()
            call MudSystemDotSt_Mud_Forehead_X%Empty()
            call St_Mud_Forehead_section%Empty()
            call St_Density%Empty()
            call MudSystemDotSt_RemainedVolume_in_LastSection%Empty()
            call MudSystemDotSt_EmptyVolume_inBackheadLocation%Empty()  
            call St_MudOrKick%Empty()                                        
            
                
            call MudSystemDotAnn_MudDischarged_Volume%Empty()
            call Ann_Mud_Backhead_X%Empty()
            call Ann_Mud_Backhead_section%Empty()
            call Ann_Mud_Forehead_X%Empty()
            call Ann_Mud_Forehead_section%Empty()
            call Ann_Density%Empty()
            call Ann_RemainedVolume_in_LastSection%Empty()
            call Ann_EmptyVolume_inBackheadLocation%Empty()
            call Ann_MudOrKick%Empty() 
            call Ann_CuttingMud%Empty() 
            
            
            call MudSystemDotOp_MudDischarged_Volume%Empty()
            call MudSystemDotOp_Mud_Backhead_X%Empty()
            call Op_Mud_Backhead_section%Empty()
            call MudSystemDotOp_Mud_Forehead_X%Empty()
            call Op_Mud_Forehead_section%Empty()
            call MudSystemDotOp_Density%Empty()
            call MudSystemDotOp_RemainedVolume_in_LastSection%Empty()
            call MudSystemDotOp_EmptyVolume_inBackheadLocation%Empty()
            call Op_MudOrKick%Empty()                                        
            

            call MudSystemDotChokeLine_MudDischarged_Volume%Empty()
            call MudSystemDotChokeLine_Mud_Backhead_X%Empty()
            call ChokeLine_Mud_Backhead_section%Empty()
            call MudSystemDotChokeLine_Mud_Forehead_X%Empty()
            call ChokeLine_Mud_Forehead_section%Empty()
            call MudSystemDotChokeLine_Density%Empty()
            call MudSystemDotChokeLine_RemainedVolume_in_LastSection%Empty()
            call MudSystemDotChokeLine_EmptyVolume_inBackheadLocation%Empty()
            call ChokeLine_MudOrKick%Empty()  
            
            
        call Xend_MudElement%Empty()
        call Xstart_MudElement%Empty()
        call TVDend_MudElement%Empty()
        call TVDstart_MudElement%Empty()
        call Density_MudElement%Empty()
        call MudGeoType%Empty()
        call PipeID_MudElement%Empty()
        call PipeOD_MudElement%Empty()
        call MudType_MudElement%Empty()            
            
        call Xend_OpMudElement%Empty()
        call Xstart_OpMudElement%Empty()
        call TVDend_OpMudElement%Empty()
        call TVDstart_OPMudElement%Empty()
        call Density_OpMudElement%Empty()
        call PipeID_OpMudElement%Empty()
        call PipeOD_OpMudElement%Empty()
        call MudTypeOp_MudElement%Empty()            
            

     
    end subroutine
    
    
    
subroutine RemoveAnnulusMudArrays(ilocal)
    USE MudSystemVARIABLES
    implicit none
    
    INTEGER :: ilocal
    
    
                    call MudSystemDotAnn_MudDischarged_Volume%Remove (ilocal)
                    call Ann_Mud_Backhead_X%Remove (ilocal)
                    call Ann_Mud_Backhead_section%Remove (ilocal)
                    call Ann_Mud_Forehead_X%Remove (ilocal)
                    call Ann_Mud_Forehead_section%Remove (ilocal)
                    call Ann_Density%Remove (ilocal)
                    call Ann_RemainedVolume_in_LastSection%Remove (ilocal)
                    call Ann_EmptyVolume_inBackheadLocation%Remove (ilocal)
                    call Ann_MudOrKick%Remove (ilocal)
                    call Ann_CuttingMud%Remove (ilocal)     
    
    
    
    end subroutine
    
    
subroutine RemoveStringMudArrays(ilocal)
    USE MudSystemVARIABLES
    implicit none
    
    INTEGER :: ilocal
    
    
                    call MudSystemDotSt_MudDischarged_Volume%Remove (ilocal)
                    call MudSystemDotSt_Mud_Backhead_X%Remove (ilocal)
                    call St_Mud_Backhead_section%Remove (ilocal)
                    call MudSystemDotSt_Mud_Forehead_X%Remove (ilocal)
                    call St_Mud_Forehead_section%Remove (ilocal)
                    call St_Density%Remove (ilocal)
                    call MudSystemDotSt_RemainedVolume_in_LastSection%Remove (ilocal)
                    call MudSystemDotSt_EmptyVolume_inBackheadLocation%Remove (ilocal)
                    call St_MudOrKick%Remove (ilocal)    
    
    
    
    end subroutine    
    
    
subroutine RemoveOpMudArrays(ilocal)
    USE MudSystemVARIABLES
    implicit none
    
    INTEGER :: ilocal
    
    
                    call MudSystemDotOp_MudDischarged_Volume%Remove (ilocal)
                    call MudSystemDotOp_Mud_Backhead_X%Remove (ilocal)
                    call Op_Mud_Backhead_section%Remove (ilocal)
                    call MudSystemDotOp_Mud_Forehead_X%Remove (ilocal)
                    call Op_Mud_Forehead_section%Remove (ilocal)
                    call MudSystemDotOp_Density%Remove (ilocal)
                    call MudSystemDotOp_RemainedVolume_in_LastSection%Remove (ilocal)
                    call MudSystemDotOp_EmptyVolume_inBackheadLocation%Remove (ilocal)
                    call Op_MudOrKick%Remove (ilocal)    
    
    
    
    end subroutine      
    
subroutine RemoveHzMudArrays(ilocal)
    USE MudSystemVARIABLES
    implicit none
    
    INTEGER :: ilocal
    
    
                    call MudSystemDotHz_MudDischarged_Volume%Remove (ilocal)
                    call MudSystemDotHz_Mud_Backhead_X%Remove (ilocal)
                    call Hz_Mud_Backhead_section%Remove (ilocal)
                    call MudSystemDotHz_Mud_Forehead_X%Remove (ilocal)
                    call Hz_Mud_Forehead_section%Remove (ilocal)
                    call MudSystemDotHz_Density%Remove (ilocal)
                    call MudSystemDotHz_RemainedVolume_in_LastSection%Remove (ilocal)
                    call MudSystemDotHz_EmptyVolume_inBackheadLocation%Remove (ilocal)
                    call Hz_MudOrKick%Remove (ilocal)    
    
    
    
     end subroutine      
   