subroutine Pumps_Outputs
    
    Use CDataDisplayConsoleVariables
    Use CSimulationVariables
    Use Pumps_VARIABLES
    Use MudSystem
    Use CDrillWatchVariables
    
	IMPLICIT NONE
    
    
    
!>>>>>>>>>>>>>>>>>>>>>>>  PUMP 1  <<<<<<<<<<<<<<<<<<<<<<<<<<<
    
    If (PUMP(1)%Open_Close==1) then
        Call OpenPump1()
    Else if (PUMP(1)%Open_Close==0) then
        Call ClosePump1()
    End if
    
    DrillingConsole%MP1BLWR = PUMP(1)%BLWR
    
    Call SetSoundBlowerMP1( PUMP(1)%SoundBlower )         !.true. or .false.
    Call SetSoundMP1( PUMP(1)%SoundSPM )                  ![spm] , integer
    
    if ((PUMP(1)%Switch==-1) .or. (PUMP(1)%Switch==0)) then
        Call Set_MP1SPMGauge( sngl(1-PUMP(1)%SPMGaugeMalf)*real((PUMP(1)%Speed/PUMP(1)%Trans_Ratio),8) )    ![spm] , real
        DrillingWatch%SPM1 = DataDisplayConsole%MP1SPMGauge
    end if
    
    !PUMP(1)%Flow_Rate   !to other modules , [gpm]
    
    
    
    
    
    
    
!>>>>>>>>>>>>>>>>>>>>>>>  PUMP 2  <<<<<<<<<<<<<<<<<<<<<<<<<<<
    
    If (PUMP(2)%Open_Close==1) then
        Call OpenPump2()
    Else if (PUMP(2)%Open_Close==0) then
        Call ClosePump2()
    End if
    
    DrillingConsole%MP2BLWR = PUMP(2)%BLWR
    
    Call SetSoundBlowerMP2( PUMP(2)%SoundBlower )
    Call SetSoundMP2( PUMP(2)%SoundSPM )
    
    Call Set_MP2SPMGauge( sngl(1-PUMP(2)%SPMGaugeMalf)*real((PUMP(2)%Speed/PUMP(2)%Trans_Ratio),8) )
    DrillingWatch%SPM2 = DataDisplayConsole%MP2SPMGauge
    
    !PUMP(2)%Flow_Rate   !to other modules
    
    
    
    
    
    
!!>>>>>>>>>>>>>>>>>>>>>>>  PUMP 3  <<<<<<<<<<<<<<<<<<<<<<<<<<<

    If (PUMP(3)%Open_Close==1) then
        Call OpenCementPump()
    Else if (PUMP(3)%Open_Close==0) then
        Call CloseCementPump()
    End if
    
    Call SetSoundMP3( PUMP(3)%SoundSPM )
    
    if (PUMP(3)%Switch==1) then
        Call Set_MP1SPMGauge( real((PUMP(3)%Speed/PUMP(3)%Trans_Ratio),8) )
        DrillingWatch%SPM1 = DataDisplayConsole%MP1SPMGauge
    end if
    
    !PUMP(3)%Flow_Rate   !to other modules
  
    
    
!>>>>>>>>>>>>>>>>>>>>>>>  Total Pumps  <<<<<<<<<<<<<<<<<<<<<<<<<<<
    
    !MPumps%Total_Pump_Gpm = 100.d0    !???????????
    !MPumps%Total_Pump_SPM = 1000.d0  !?????????????
    
    !SCR1LED=1
    !SCR2LED=1
    !SCR3LED=1
    !SCR4LED=1
    
    
    
    
end subroutine Pumps_Outputs