subroutine Pumps_Inputs
    
    Use CDrillingConsoleVariables
    Use Pumps_VARIABLES
    Use MudSystem
    
	IMPLICIT NONE
    
    
    
!>>>>>>>>>>>>>>>>>>>>>>>  PUMP 1  <<<<<<<<<<<<<<<<<<<<<<<<<<<

    !PUMP(1)%BlowPopOffMalf     = 0                  !??????? motaghayere voroudi
    
    if ( PUMP(1)%BlowPopOffMalf==1 ) then            ! Pump1 Malfunction ----> Blow Pop-offs (Relief Valves)
        PUMP(1)%StandPipe_Pressure = 0.d0
    else
        PUMP(1)%StandPipe_Pressure = PumpPressure1   ![psi]
        if ( PUMP(1)%StandPipe_Pressure<=14.d0 ) then
            PUMP(1)%StandPipe_Pressure = 14.d0
        end if
    end if
    
    PUMP(1)%AssignmentSwitchh  = DrillingConsole%AssignmentSwitch
    
    PUMP(1)%Switch             = DrillingConsole%MP1CPSwitch
    
    PUMP(1)%Throttle           = DrillingConsole%MP1Throttle         ![RPM]
    
    !PUMP(1)%PowerFailMalf     = 0                   !??????? motaghayere voroudi   (Pump1 Malfunction ----> Power Failure) !dar CPumpProblemsVariables meghdardehi mishavad
    
    PUMP(1)%Failure            = Pump1Failure        !(Pump1 Warning ----> Failure)
        
    PUMP(1)%N_new              = PUMP(1)%Throttle
    
    
    
    

    
    
!>>>>>>>>>>>>>>>>>>>>>>>  PUMP 2  <<<<<<<<<<<<<<<<<<<<<<<<<<<

    !PUMP(2)%BlowPopOffMalf     = 0                  !??????? motaghayere voroudi
    
    if ( PUMP(2)%BlowPopOffMalf==1 ) then            ! Pump2 Malfunction ----> Blow Pop-offs (Relief Valves)
        PUMP(2)%StandPipe_Pressure = 0.d0
    else
        PUMP(2)%StandPipe_Pressure = PumpPressure2   ![psi]
        if ( PUMP(2)%StandPipe_Pressure<=14.d0 ) then
            PUMP(2)%StandPipe_Pressure = 14.d0
        end if
    end if
    
    PUMP(2)%AssignmentSwitchh  = DrillingConsole%AssignmentSwitch
    
    PUMP(2)%Switch             = DrillingConsole%MP2Switch
    
    PUMP(2)%Throttle           = DrillingConsole%MP2Throttle         ![RPM]
    
    !PUMP(2)%PowerFailMalf     = 0                   !??????? motaghayere voroudi   (Pump2 Malfunction ----> Power Failure) !dar CPumpProblemsVariables meghdardehi mishavad
    
    PUMP(2)%Failure            = Pump2Failure        !(Pump2 Warning ----> Failure)
    
    PUMP(2)%N_new              = PUMP(2)%Throttle
    
    
    
    
    
    
    
!!>>>>>>>>>>>>>>>>>>>>>>>  PUMP 3  <<<<<<<<<<<<<<<<<<<<<<<<<<<

    !PUMP(3)%BlowPopOffMalf     = 0                  !??????? motaghayere voroudi
    
    if ( PUMP(3)%BlowPopOffMalf==1 ) then            ! Pump3 Malfunction ----> Blow Pop-offs (Relief Valves)
        PUMP(3)%StandPipe_Pressure = 0.d0
    else
        PUMP(3)%StandPipe_Pressure = PumpPressure3   ![psi]
        if ( PUMP(3)%StandPipe_Pressure<=14.d0 ) then
            PUMP(3)%StandPipe_Pressure = 14.d0
        end if
    end if
        
    PUMP(3)%Switch             = DrillingConsole%MP1CPSwitch
    
    PUMP(3)%Throttle           = DrillingConsole%MP1Throttle         ![RPM]
    
    !PUMP(3)%PowerFailMalf     = 0                   !??????? motaghayere voroudi   (Pump3 Malfunction ----> Power Failure) !dar CPumpProblemsVariables meghdardehi mishavad
    
    PUMP(3)%Failure            = Pump3Failure        !(Pump1 Warning ----> Failure)
        
    PUMP(3)%N_new              = PUMP(3)%Throttle
  
    
    
    
    
    
!>>>>>>>>>>>>>>>>>>>>>>>  Total Pumps  <<<<<<<<<<<<<<<<<<<<<<<<<<<
    
    
    
    
    
    
    
    
end subroutine Pumps_Inputs